﻿/*
 * MobileLaptopRemote
 * Alexandre Alapetite, 2007-05-09 / 2007-05-10, http://alexandre.alapetite.net
 * Encoding: Unicode UTF-8 (example: français, København)
 */
using System;
using System.IO.Ports;
using System.Net;
using System.Net.Sockets;
using System.Windows.Forms;
using System.Text;
using System.Threading;

namespace MobileLaptopRemote
{
	/// <summary>
	/// Description of MobileLaptopRemote.
	/// </summary>
	public sealed class MobileLaptopRemote2 : Form
	{
		private SerialPort serialPortNXT;
		
		[STAThread]
		public static void Main(string[] args)
		{
			Application.EnableVisualStyles();
			Application.SetCompatibleTextRenderingDefault(false);
			Application.Run(new MobileLaptopRemote2());
		}
		
		public MobileLaptopRemote2()
		{
			InitializeComponent();
		}
		
		#region Graphic interface
		/// <summary>
		/// Designer variable used to keep track of non-visual components.
		/// </summary>
		private System.ComponentModel.IContainer components = null;
		
		/// <summary>
		/// Disposes resources used by the form.
		/// </summary>
		/// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
		protected override void Dispose(bool disposing)
		{
			if (disposing) {
				if (components != null) {
					components.Dispose();
				}
			}
			base.Dispose(disposing);
		}
		
		/// <summary>
		/// This method is required for Windows Forms designer support.
		/// Do not change the method contents inside the source code editor. The Forms designer might
		/// not be able to load this method if it was changed manually.
		/// </summary>
		private void InitializeComponent()
		{
			this.tabControl1 = new System.Windows.Forms.TabControl();
			this.tabPageSetup = new System.Windows.Forms.TabPage();
			this.groupBoxIPtransport = new System.Windows.Forms.GroupBox();
			this.radioButtonTCP = new System.Windows.Forms.RadioButton();
			this.radioButtonUDP = new System.Windows.Forms.RadioButton();
			this.groupBoxMode = new System.Windows.Forms.GroupBox();
			this.radioButtonModeRelayed = new System.Windows.Forms.RadioButton();
			this.radioButtonModeDirect = new System.Windows.Forms.RadioButton();
			this.groupBoxIPmaster = new System.Windows.Forms.GroupBox();
			this.labelIP = new System.Windows.Forms.Label();
			this.textBoxIP = new System.Windows.Forms.TextBox();
			this.numericUpDownIPMaster = new System.Windows.Forms.NumericUpDown();
			this.labelPortMaster = new System.Windows.Forms.Label();
			this.buttonIPmaster = new System.Windows.Forms.Button();
			this.groupBoxIPslave = new System.Windows.Forms.GroupBox();
			this.numericUpDownIPslave = new System.Windows.Forms.NumericUpDown();
			this.labelPortslave = new System.Windows.Forms.Label();
			this.buttonIPslave = new System.Windows.Forms.Button();
			this.groupBoxBluetooth = new System.Windows.Forms.GroupBox();
			this.buttonBluetooth = new System.Windows.Forms.Button();
			this.labelComPort = new System.Windows.Forms.Label();
			this.numericUpDownBluetoothPort = new System.Windows.Forms.NumericUpDown();
			this.tabPageRemote = new System.Windows.Forms.TabPage();
			this.textBoxMessagesReceived = new System.Windows.Forms.TextBox();
			this.groupBoxPilot = new System.Windows.Forms.GroupBox();
			this.buttonBackRight = new System.Windows.Forms.Button();
			this.buttonBackLeft = new System.Windows.Forms.Button();
			this.buttonBack = new System.Windows.Forms.Button();
			this.buttonFrontRight = new System.Windows.Forms.Button();
			this.buttonFrontLeft = new System.Windows.Forms.Button();
			this.buttonFront = new System.Windows.Forms.Button();
			this.buttonStop = new System.Windows.Forms.Button();
			this.statusStrip1 = new System.Windows.Forms.StatusStrip();
			this.toolStripStatusLabelAlex = new System.Windows.Forms.ToolStripStatusLabel();
			this.tabControl1.SuspendLayout();
			this.tabPageSetup.SuspendLayout();
			this.groupBoxIPtransport.SuspendLayout();
			this.groupBoxMode.SuspendLayout();
			this.groupBoxIPmaster.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownIPMaster)).BeginInit();
			this.groupBoxIPslave.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownIPslave)).BeginInit();
			this.groupBoxBluetooth.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownBluetoothPort)).BeginInit();
			this.tabPageRemote.SuspendLayout();
			this.groupBoxPilot.SuspendLayout();
			this.statusStrip1.SuspendLayout();
			this.SuspendLayout();
			// 
			// tabControl1
			// 
			this.tabControl1.Controls.Add(this.tabPageSetup);
			this.tabControl1.Controls.Add(this.tabPageRemote);
			this.tabControl1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.tabControl1.Location = new System.Drawing.Point(0, 0);
			this.tabControl1.Name = "tabControl1";
			this.tabControl1.SelectedIndex = 0;
			this.tabControl1.Size = new System.Drawing.Size(304, 360);
			this.tabControl1.TabIndex = 3;
			// 
			// tabPageSetup
			// 
			this.tabPageSetup.Controls.Add(this.groupBoxIPtransport);
			this.tabPageSetup.Controls.Add(this.groupBoxMode);
			this.tabPageSetup.Controls.Add(this.groupBoxIPmaster);
			this.tabPageSetup.Controls.Add(this.groupBoxIPslave);
			this.tabPageSetup.Controls.Add(this.groupBoxBluetooth);
			this.tabPageSetup.Location = new System.Drawing.Point(4, 22);
			this.tabPageSetup.Name = "tabPageSetup";
			this.tabPageSetup.Padding = new System.Windows.Forms.Padding(3);
			this.tabPageSetup.Size = new System.Drawing.Size(296, 334);
			this.tabPageSetup.TabIndex = 0;
			this.tabPageSetup.Text = "Setup";
			this.tabPageSetup.UseVisualStyleBackColor = true;
			// 
			// groupBoxIPtransport
			// 
			this.groupBoxIPtransport.Controls.Add(this.radioButtonTCP);
			this.groupBoxIPtransport.Controls.Add(this.radioButtonUDP);
			this.groupBoxIPtransport.Location = new System.Drawing.Point(8, 177);
			this.groupBoxIPtransport.Name = "groupBoxIPtransport";
			this.groupBoxIPtransport.Size = new System.Drawing.Size(280, 50);
			this.groupBoxIPtransport.TabIndex = 4;
			this.groupBoxIPtransport.TabStop = false;
			this.groupBoxIPtransport.Text = "IP transport";
			// 
			// radioButtonTCP
			// 
			this.radioButtonTCP.Enabled = false;
			this.radioButtonTCP.Location = new System.Drawing.Point(170, 19);
			this.radioButtonTCP.Name = "radioButtonTCP";
			this.radioButtonTCP.Size = new System.Drawing.Size(104, 24);
			this.radioButtonTCP.TabIndex = 1;
			this.radioButtonTCP.Text = "TCP";
			this.radioButtonTCP.UseVisualStyleBackColor = true;
			// 
			// radioButtonUDP
			// 
			this.radioButtonUDP.Checked = true;
			this.radioButtonUDP.Location = new System.Drawing.Point(60, 19);
			this.radioButtonUDP.Name = "radioButtonUDP";
			this.radioButtonUDP.Size = new System.Drawing.Size(104, 24);
			this.radioButtonUDP.TabIndex = 0;
			this.radioButtonUDP.TabStop = true;
			this.radioButtonUDP.Text = "UDP";
			this.radioButtonUDP.UseVisualStyleBackColor = true;
			// 
			// groupBoxMode
			// 
			this.groupBoxMode.Controls.Add(this.radioButtonModeRelayed);
			this.groupBoxMode.Controls.Add(this.radioButtonModeDirect);
			this.groupBoxMode.Location = new System.Drawing.Point(8, 6);
			this.groupBoxMode.Name = "groupBoxMode";
			this.groupBoxMode.Size = new System.Drawing.Size(280, 50);
			this.groupBoxMode.TabIndex = 3;
			this.groupBoxMode.TabStop = false;
			this.groupBoxMode.Text = "Remote control mode";
			// 
			// radioButtonModeRelayed
			// 
			this.radioButtonModeRelayed.Location = new System.Drawing.Point(170, 19);
			this.radioButtonModeRelayed.Name = "radioButtonModeRelayed";
			this.radioButtonModeRelayed.Size = new System.Drawing.Size(104, 24);
			this.radioButtonModeRelayed.TabIndex = 1;
			this.radioButtonModeRelayed.Text = "Relayed";
			this.radioButtonModeRelayed.UseVisualStyleBackColor = true;
			this.radioButtonModeRelayed.CheckedChanged += new System.EventHandler(this.RadioButtonModeCheckedChanged);
			// 
			// radioButtonModeDirect
			// 
			this.radioButtonModeDirect.Checked = true;
			this.radioButtonModeDirect.Location = new System.Drawing.Point(60, 19);
			this.radioButtonModeDirect.Name = "radioButtonModeDirect";
			this.radioButtonModeDirect.Size = new System.Drawing.Size(104, 24);
			this.radioButtonModeDirect.TabIndex = 0;
			this.radioButtonModeDirect.TabStop = true;
			this.radioButtonModeDirect.Text = "Direct";
			this.radioButtonModeDirect.UseVisualStyleBackColor = true;
			this.radioButtonModeDirect.CheckedChanged += new System.EventHandler(this.RadioButtonModeCheckedChanged);
			// 
			// groupBoxIPmaster
			// 
			this.groupBoxIPmaster.Controls.Add(this.labelIP);
			this.groupBoxIPmaster.Controls.Add(this.textBoxIP);
			this.groupBoxIPmaster.Controls.Add(this.numericUpDownIPMaster);
			this.groupBoxIPmaster.Controls.Add(this.labelPortMaster);
			this.groupBoxIPmaster.Controls.Add(this.buttonIPmaster);
			this.groupBoxIPmaster.Enabled = false;
			this.groupBoxIPmaster.Location = new System.Drawing.Point(8, 233);
			this.groupBoxIPmaster.Name = "groupBoxIPmaster";
			this.groupBoxIPmaster.Size = new System.Drawing.Size(280, 73);
			this.groupBoxIPmaster.TabIndex = 2;
			this.groupBoxIPmaster.TabStop = false;
			this.groupBoxIPmaster.Text = "IP remote master";
			// 
			// labelIP
			// 
			this.labelIP.Location = new System.Drawing.Point(6, 45);
			this.labelIP.Name = "labelIP";
			this.labelIP.Size = new System.Drawing.Size(93, 20);
			this.labelIP.TabIndex = 7;
			this.labelIP.Text = "IP address";
			this.labelIP.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// textBoxIP
			// 
			this.textBoxIP.Location = new System.Drawing.Point(105, 45);
			this.textBoxIP.MaxLength = 512;
			this.textBoxIP.Name = "textBoxIP";
			this.textBoxIP.Size = new System.Drawing.Size(169, 20);
			this.textBoxIP.TabIndex = 6;
			// 
			// numericUpDownIPMaster
			// 
			this.numericUpDownIPMaster.Location = new System.Drawing.Point(105, 19);
			this.numericUpDownIPMaster.Maximum = new decimal(new int[] {
									9999,
									0,
									0,
									0});
			this.numericUpDownIPMaster.Minimum = new decimal(new int[] {
									1000,
									0,
									0,
									0});
			this.numericUpDownIPMaster.Name = "numericUpDownIPMaster";
			this.numericUpDownIPMaster.Size = new System.Drawing.Size(55, 20);
			this.numericUpDownIPMaster.TabIndex = 5;
			this.numericUpDownIPMaster.Value = new decimal(new int[] {
									2411,
									0,
									0,
									0});
			// 
			// labelPortMaster
			// 
			this.labelPortMaster.Location = new System.Drawing.Point(6, 16);
			this.labelPortMaster.Name = "labelPortMaster";
			this.labelPortMaster.Size = new System.Drawing.Size(93, 23);
			this.labelPortMaster.TabIndex = 4;
			this.labelPortMaster.Text = "Transport port";
			this.labelPortMaster.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// buttonIPmaster
			// 
			this.buttonIPmaster.Location = new System.Drawing.Point(199, 16);
			this.buttonIPmaster.Name = "buttonIPmaster";
			this.buttonIPmaster.Size = new System.Drawing.Size(75, 23);
			this.buttonIPmaster.TabIndex = 3;
			this.buttonIPmaster.Text = "Activate";
			this.buttonIPmaster.UseVisualStyleBackColor = true;
			this.buttonIPmaster.Click += new System.EventHandler(this.ButtonIPmasterClick);
			// 
			// groupBoxIPslave
			// 
			this.groupBoxIPslave.Controls.Add(this.numericUpDownIPslave);
			this.groupBoxIPslave.Controls.Add(this.labelPortslave);
			this.groupBoxIPslave.Controls.Add(this.buttonIPslave);
			this.groupBoxIPslave.Location = new System.Drawing.Point(8, 118);
			this.groupBoxIPslave.Name = "groupBoxIPslave";
			this.groupBoxIPslave.Size = new System.Drawing.Size(280, 53);
			this.groupBoxIPslave.TabIndex = 1;
			this.groupBoxIPslave.TabStop = false;
			this.groupBoxIPslave.Text = "IP remote slave";
			// 
			// numericUpDownIPslave
			// 
			this.numericUpDownIPslave.Location = new System.Drawing.Point(105, 19);
			this.numericUpDownIPslave.Maximum = new decimal(new int[] {
									9999,
									0,
									0,
									0});
			this.numericUpDownIPslave.Minimum = new decimal(new int[] {
									1000,
									0,
									0,
									0});
			this.numericUpDownIPslave.Name = "numericUpDownIPslave";
			this.numericUpDownIPslave.Size = new System.Drawing.Size(55, 20);
			this.numericUpDownIPslave.TabIndex = 5;
			this.numericUpDownIPslave.Value = new decimal(new int[] {
									2411,
									0,
									0,
									0});
			// 
			// labelPortslave
			// 
			this.labelPortslave.Location = new System.Drawing.Point(6, 16);
			this.labelPortslave.Name = "labelPortslave";
			this.labelPortslave.Size = new System.Drawing.Size(93, 23);
			this.labelPortslave.TabIndex = 4;
			this.labelPortslave.Text = "Transport port";
			this.labelPortslave.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// buttonIPslave
			// 
			this.buttonIPslave.Location = new System.Drawing.Point(199, 16);
			this.buttonIPslave.Name = "buttonIPslave";
			this.buttonIPslave.Size = new System.Drawing.Size(75, 23);
			this.buttonIPslave.TabIndex = 3;
			this.buttonIPslave.Text = "Listen";
			this.buttonIPslave.UseVisualStyleBackColor = true;
			this.buttonIPslave.Click += new System.EventHandler(this.ButtonIPslaveClick);
			// 
			// groupBoxBluetooth
			// 
			this.groupBoxBluetooth.Controls.Add(this.buttonBluetooth);
			this.groupBoxBluetooth.Controls.Add(this.labelComPort);
			this.groupBoxBluetooth.Controls.Add(this.numericUpDownBluetoothPort);
			this.groupBoxBluetooth.Location = new System.Drawing.Point(8, 62);
			this.groupBoxBluetooth.Name = "groupBoxBluetooth";
			this.groupBoxBluetooth.Size = new System.Drawing.Size(280, 50);
			this.groupBoxBluetooth.TabIndex = 0;
			this.groupBoxBluetooth.TabStop = false;
			this.groupBoxBluetooth.Text = "Bluetooth client";
			// 
			// buttonBluetooth
			// 
			this.buttonBluetooth.Location = new System.Drawing.Point(199, 15);
			this.buttonBluetooth.Name = "buttonBluetooth";
			this.buttonBluetooth.Size = new System.Drawing.Size(75, 23);
			this.buttonBluetooth.TabIndex = 2;
			this.buttonBluetooth.Text = "Connect";
			this.buttonBluetooth.UseVisualStyleBackColor = true;
			this.buttonBluetooth.Click += new System.EventHandler(this.ButtonBluetoothClick);
			// 
			// labelComPort
			// 
			this.labelComPort.Location = new System.Drawing.Point(6, 16);
			this.labelComPort.Name = "labelComPort";
			this.labelComPort.Size = new System.Drawing.Size(93, 20);
			this.labelComPort.TabIndex = 1;
			this.labelComPort.Text = "Serial port COM";
			this.labelComPort.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// numericUpDownBluetoothPort
			// 
			this.numericUpDownBluetoothPort.Location = new System.Drawing.Point(105, 18);
			this.numericUpDownBluetoothPort.Maximum = new decimal(new int[] {
									99,
									0,
									0,
									0});
			this.numericUpDownBluetoothPort.Minimum = new decimal(new int[] {
									1,
									0,
									0,
									0});
			this.numericUpDownBluetoothPort.Name = "numericUpDownBluetoothPort";
			this.numericUpDownBluetoothPort.Size = new System.Drawing.Size(55, 20);
			this.numericUpDownBluetoothPort.TabIndex = 0;
			this.numericUpDownBluetoothPort.Value = new decimal(new int[] {
									14,
									0,
									0,
									0});
			// 
			// tabPageRemote
			// 
			this.tabPageRemote.Controls.Add(this.textBoxMessagesReceived);
			this.tabPageRemote.Controls.Add(this.groupBoxPilot);
			this.tabPageRemote.Location = new System.Drawing.Point(4, 22);
			this.tabPageRemote.Name = "tabPageRemote";
			this.tabPageRemote.Padding = new System.Windows.Forms.Padding(3);
			this.tabPageRemote.Size = new System.Drawing.Size(296, 334);
			this.tabPageRemote.TabIndex = 1;
			this.tabPageRemote.Text = "Remote control";
			this.tabPageRemote.UseVisualStyleBackColor = true;
			// 
			// textBoxMessagesReceived
			// 
			this.textBoxMessagesReceived.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
									| System.Windows.Forms.AnchorStyles.Left) 
									| System.Windows.Forms.AnchorStyles.Right)));
			this.textBoxMessagesReceived.Font = new System.Drawing.Font("Lucida Sans Unicode", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.textBoxMessagesReceived.Location = new System.Drawing.Point(8, 196);
			this.textBoxMessagesReceived.Multiline = true;
			this.textBoxMessagesReceived.Name = "textBoxMessagesReceived";
			this.textBoxMessagesReceived.ReadOnly = true;
			this.textBoxMessagesReceived.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
			this.textBoxMessagesReceived.Size = new System.Drawing.Size(280, 117);
			this.textBoxMessagesReceived.TabIndex = 12;
			// 
			// groupBoxPilot
			// 
			this.groupBoxPilot.Controls.Add(this.buttonBackRight);
			this.groupBoxPilot.Controls.Add(this.buttonBackLeft);
			this.groupBoxPilot.Controls.Add(this.buttonBack);
			this.groupBoxPilot.Controls.Add(this.buttonFrontRight);
			this.groupBoxPilot.Controls.Add(this.buttonFrontLeft);
			this.groupBoxPilot.Controls.Add(this.buttonFront);
			this.groupBoxPilot.Controls.Add(this.buttonStop);
			this.groupBoxPilot.Enabled = false;
			this.groupBoxPilot.Location = new System.Drawing.Point(6, 6);
			this.groupBoxPilot.Name = "groupBoxPilot";
			this.groupBoxPilot.Size = new System.Drawing.Size(282, 184);
			this.groupBoxPilot.TabIndex = 5;
			this.groupBoxPilot.TabStop = false;
			this.groupBoxPilot.Text = "Pilot";
			// 
			// buttonBackRight
			// 
			this.buttonBackRight.Font = new System.Drawing.Font("Lucida Sans Unicode", 27.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.buttonBackRight.Location = new System.Drawing.Point(170, 123);
			this.buttonBackRight.Name = "buttonBackRight";
			this.buttonBackRight.Size = new System.Drawing.Size(46, 46);
			this.buttonBackRight.TabIndex = 11;
			this.buttonBackRight.Text = "↘";
			this.buttonBackRight.UseVisualStyleBackColor = true;
			this.buttonBackRight.MouseDown += new System.Windows.Forms.MouseEventHandler(this.ButtonBackRightMouseDown);
			// 
			// buttonBackLeft
			// 
			this.buttonBackLeft.Font = new System.Drawing.Font("Lucida Sans Unicode", 27.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.buttonBackLeft.Location = new System.Drawing.Point(66, 123);
			this.buttonBackLeft.Name = "buttonBackLeft";
			this.buttonBackLeft.Size = new System.Drawing.Size(46, 46);
			this.buttonBackLeft.TabIndex = 10;
			this.buttonBackLeft.Text = "↙";
			this.buttonBackLeft.UseVisualStyleBackColor = true;
			this.buttonBackLeft.MouseDown += new System.Windows.Forms.MouseEventHandler(this.ButtonBackLeftMouseDown);
			// 
			// buttonBack
			// 
			this.buttonBack.Font = new System.Drawing.Font("Lucida Sans Unicode", 27.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.buttonBack.Location = new System.Drawing.Point(118, 123);
			this.buttonBack.Name = "buttonBack";
			this.buttonBack.Size = new System.Drawing.Size(46, 46);
			this.buttonBack.TabIndex = 9;
			this.buttonBack.Text = "↓";
			this.buttonBack.UseVisualStyleBackColor = true;
			this.buttonBack.MouseDown += new System.Windows.Forms.MouseEventHandler(this.ButtonBackMouseDown);
			// 
			// buttonFrontRight
			// 
			this.buttonFrontRight.Font = new System.Drawing.Font("Lucida Sans Unicode", 27.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.buttonFrontRight.Location = new System.Drawing.Point(170, 19);
			this.buttonFrontRight.Name = "buttonFrontRight";
			this.buttonFrontRight.Size = new System.Drawing.Size(46, 46);
			this.buttonFrontRight.TabIndex = 8;
			this.buttonFrontRight.Text = "↗";
			this.buttonFrontRight.UseVisualStyleBackColor = true;
			this.buttonFrontRight.MouseDown += new System.Windows.Forms.MouseEventHandler(this.ButtonFrontRightMouseDown);
			// 
			// buttonFrontLeft
			// 
			this.buttonFrontLeft.Font = new System.Drawing.Font("Lucida Sans Unicode", 27.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.buttonFrontLeft.Location = new System.Drawing.Point(66, 19);
			this.buttonFrontLeft.Name = "buttonFrontLeft";
			this.buttonFrontLeft.Size = new System.Drawing.Size(46, 46);
			this.buttonFrontLeft.TabIndex = 7;
			this.buttonFrontLeft.Text = "↖";
			this.buttonFrontLeft.UseVisualStyleBackColor = true;
			this.buttonFrontLeft.MouseDown += new System.Windows.Forms.MouseEventHandler(this.ButtonFrontLeftMouseDown);
			// 
			// buttonFront
			// 
			this.buttonFront.Font = new System.Drawing.Font("Lucida Sans Unicode", 27.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.buttonFront.Location = new System.Drawing.Point(118, 19);
			this.buttonFront.Name = "buttonFront";
			this.buttonFront.Size = new System.Drawing.Size(46, 46);
			this.buttonFront.TabIndex = 6;
			this.buttonFront.Text = "↑";
			this.buttonFront.UseVisualStyleBackColor = true;
			this.buttonFront.MouseDown += new System.Windows.Forms.MouseEventHandler(this.ButtonFrontMouseDown);
			// 
			// buttonStop
			// 
			this.buttonStop.Font = new System.Drawing.Font("Lucida Sans Unicode", 24F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.buttonStop.Location = new System.Drawing.Point(118, 71);
			this.buttonStop.Name = "buttonStop";
			this.buttonStop.Size = new System.Drawing.Size(46, 46);
			this.buttonStop.TabIndex = 5;
			this.buttonStop.Text = "■";
			this.buttonStop.UseVisualStyleBackColor = true;
			this.buttonStop.MouseDown += new System.Windows.Forms.MouseEventHandler(this.ButtonStopMouseDown);
			this.buttonStop.MouseUp += new System.Windows.Forms.MouseEventHandler(this.ButtonStopMouseUp);
			// 
			// statusStrip1
			// 
			this.statusStrip1.Items.AddRange(new System.Windows.Forms.ToolStripItem[] {
									this.toolStripStatusLabelAlex});
			this.statusStrip1.Location = new System.Drawing.Point(0, 338);
			this.statusStrip1.Name = "statusStrip1";
			this.statusStrip1.Size = new System.Drawing.Size(304, 22);
			this.statusStrip1.TabIndex = 4;
			this.statusStrip1.Text = "statusStrip1";
			// 
			// toolStripStatusLabelAlex
			// 
			this.toolStripStatusLabelAlex.Name = "toolStripStatusLabelAlex";
			this.toolStripStatusLabelAlex.Size = new System.Drawing.Size(136, 17);
			this.toolStripStatusLabelAlex.Text = "Alexandre Alapetite 2007";
			// 
			// MobileLaptopRemote2
			// 
			this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
			this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
			this.ClientSize = new System.Drawing.Size(304, 360);
			this.Controls.Add(this.statusStrip1);
			this.Controls.Add(this.tabControl1);
			this.MaximizeBox = false;
			this.MinimumSize = new System.Drawing.Size(320, 396);
			this.Name = "MobileLaptopRemote2";
			this.Text = "MobileLaptopRemote 2.1.1";
			this.tabControl1.ResumeLayout(false);
			this.tabPageSetup.ResumeLayout(false);
			this.groupBoxIPtransport.ResumeLayout(false);
			this.groupBoxMode.ResumeLayout(false);
			this.groupBoxIPmaster.ResumeLayout(false);
			this.groupBoxIPmaster.PerformLayout();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownIPMaster)).EndInit();
			this.groupBoxIPslave.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownIPslave)).EndInit();
			this.groupBoxBluetooth.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownBluetoothPort)).EndInit();
			this.tabPageRemote.ResumeLayout(false);
			this.tabPageRemote.PerformLayout();
			this.groupBoxPilot.ResumeLayout(false);
			this.statusStrip1.ResumeLayout(false);
			this.statusStrip1.PerformLayout();
			this.ResumeLayout(false);
			this.PerformLayout();
		}
		private System.Windows.Forms.RadioButton radioButtonUDP;
		private System.Windows.Forms.RadioButton radioButtonTCP;
		private System.Windows.Forms.GroupBox groupBoxIPtransport;
		private System.Windows.Forms.Label labelPortMaster;
		private System.Windows.Forms.Label labelPortslave;
		private System.Windows.Forms.GroupBox groupBoxIPslave;
		private System.Windows.Forms.GroupBox groupBoxIPmaster;
		private System.Windows.Forms.TextBox textBoxMessagesReceived;
		private System.Windows.Forms.NumericUpDown numericUpDownIPMaster;
		private System.Windows.Forms.NumericUpDown numericUpDownIPslave;
		private System.Windows.Forms.NumericUpDown numericUpDownBluetoothPort;
		private System.Windows.Forms.Button buttonBluetooth;
		private System.Windows.Forms.Button buttonFront;
		private System.Windows.Forms.Button buttonFrontLeft;
		private System.Windows.Forms.Button buttonFrontRight;
		private System.Windows.Forms.Button buttonBack;
		private System.Windows.Forms.Button buttonBackLeft;
		private System.Windows.Forms.Button buttonBackRight;
		private System.Windows.Forms.Button buttonStop;
		private System.Windows.Forms.ToolStripStatusLabel toolStripStatusLabelAlex;
		private System.Windows.Forms.StatusStrip statusStrip1;
		private System.Windows.Forms.GroupBox groupBoxPilot;
		private System.Windows.Forms.TabPage tabPageRemote;
		private System.Windows.Forms.Label labelComPort;
		private System.Windows.Forms.GroupBox groupBoxBluetooth;
		private System.Windows.Forms.Button buttonIPslave;
		private System.Windows.Forms.Button buttonIPmaster;
		private System.Windows.Forms.TextBox textBoxIP;
		private System.Windows.Forms.Label labelIP;
		private System.Windows.Forms.RadioButton radioButtonModeDirect;
		private System.Windows.Forms.RadioButton radioButtonModeRelayed;
		private System.Windows.Forms.GroupBox groupBoxMode;
		private System.Windows.Forms.TabPage tabPageSetup;
		private System.Windows.Forms.TabControl tabControl1;
		#endregion
		
		void ButtonBluetoothClick(object sender, EventArgs e)
		{
			if (numericUpDownBluetoothPort.Enabled)
			{
				buttonBluetooth.Enabled = false;
				numericUpDownBluetoothPort.Enabled = false;
				buttonBluetooth.Text = "Disconnect";
				serialPortNXT = new SerialPort("COM" + numericUpDownBluetoothPort.Value);
				serialPortNXT.Open();
				//serialPortNXT.ReadTimeout = 1500;
				buttonBluetooth.Enabled = true;
				groupBoxPilot.Enabled = true;
			}
			else
			{
				groupBoxPilot.Enabled = false;
				buttonBluetooth.Enabled = false;
				serialPortNXT.Close();
				serialPortNXT.Dispose();
				serialPortNXT = null;
				buttonBluetooth.Text = "Connect";
				numericUpDownBluetoothPort.Enabled = true;
				buttonBluetooth.Enabled = true;
			}
		}
		
		private void sendBluetoothMessage(byte mailbox, int message)
		{
			//http://mindstorms.lego.com/Overview/NXTreme.aspx (Appendix 2-LEGO MINDSTORMS NXT Direct commands.pdf)
			//http://www.codeproject.com/useritems/nxtBluetooth.asp
			byte[] mess = System.BitConverter.GetBytes(message);
			if (!System.BitConverter.IsLittleEndian) Array.Reverse(mess);
			byte[] nxtMessage =
			{
				//Header: following command length (least significant byte first)
				0x09, 0x00,//(byte)(length & 0xFF), (byte)((length & 0xFF00) >>8)
				//Command
				0x80, //Command type: {0x00: Direct command, reply required; 0x01: System command, reply required; 0x02: Reply command; 0x80: Direct command, reply not required; 0x81: System command, reply not required}
				0x09, //Command byte: message write
				--mailbox, //0-based mailbox number (0..9)
				0x05, //datalength including terminator byte
				mess[0], mess[1], mess[2], mess[3], //data (here an Int32, Little Endian)
				0x00 //terminator byte
			};
			serialPortNXT.Write(nxtMessage, 0, nxtMessage.Length);
		}
		
		void RadioButtonModeCheckedChanged(object sender, EventArgs e)
		{
			if (radioButtonModeDirect.Checked)
			{
				if (groupBoxIPmaster.Enabled && (!numericUpDownIPMaster.Enabled))
					ButtonIPmasterClick(sender, e); //Stop IP master
				groupBoxBluetooth.Enabled = true;
				groupBoxIPmaster.Enabled = false;
			}
			else
			{
				if (groupBoxBluetooth.Enabled && (!numericUpDownBluetoothPort.Enabled))
					ButtonBluetoothClick(sender, e); //Disconnect Bluetooth
				groupBoxBluetooth.Enabled = false;
				groupBoxIPmaster.Enabled = true;
			}
		}
		
		void ButtonBackLeftMouseDown(object sender, MouseEventArgs e)
		{
			if (radioButtonModeDirect.Checked) sendBluetoothMessage(1, 1);
			else SendUDPmessage("<BackLeft/>");
		}
		
		void ButtonBackMouseDown(object sender, MouseEventArgs e)
		{
			if (radioButtonModeDirect.Checked) sendBluetoothMessage(1, 2);
			else SendUDPmessage("<Back/>");
		}
		
		void ButtonBackRightMouseDown(object sender, MouseEventArgs e)
		{
			if (radioButtonModeDirect.Checked) sendBluetoothMessage(1, 3);
			else SendUDPmessage("<BackRight/>");
		}
		
		void ButtonStopMouseDown(object sender, MouseEventArgs e)
		{
			if (radioButtonModeDirect.Checked) sendBluetoothMessage(1, 5);
			else SendUDPmessage("<Stop>");
		}
		
		void ButtonStopMouseUp(object sender, MouseEventArgs e)
		{
			if (radioButtonModeDirect.Checked) sendBluetoothMessage(1, 0);
			else SendUDPmessage("</Stop>");
		}
		
		void ButtonFrontLeftMouseDown(object sender, MouseEventArgs e)
		{
			if (radioButtonModeDirect.Checked) sendBluetoothMessage(1, 7);
			else SendUDPmessage("<FrontLeft/>");
		}
		
		void ButtonFrontMouseDown(object sender, MouseEventArgs e)
		{
			if (radioButtonModeDirect.Checked) sendBluetoothMessage(1, 8);
			else SendUDPmessage("<Front/>");				
		}
		
		void ButtonFrontRightMouseDown(object sender, MouseEventArgs e)
		{
			if (radioButtonModeDirect.Checked) sendBluetoothMessage(1, 9);
			else SendUDPmessage("<FrontRight/>");
		}
		
		#region IP slave
		UdpClient udpClientSlave;
		
		void UDPmessageReceived(IAsyncResult iAsyncResult)
		{
			if (udpClientSlave == null) return;
			IPEndPoint ipEndPoint = new IPEndPoint(IPAddress.Any, (int)numericUpDownIPslave.Value);
			Byte[] bytes = udpClientSlave.EndReceive(iAsyncResult, ref ipEndPoint);
			string message = Encoding.UTF8.GetString(bytes);
			bytes = Encoding.UTF8.GetBytes("<ok/>");
			try
			{
				udpClientSlave.Send(bytes, bytes.Length, ipEndPoint);
			}
			catch (Exception e)
			{
				textBoxMessagesReceived.AppendText(e.ToString());
			}
			this.Invoke(new ReceivedUDPmessageDelegate(ReceivedUDPmessage), new object[] {message, ipEndPoint.Address.ToString()});
			if (udpClientSlave != null)
				udpClientSlave.BeginReceive(UDPmessageReceived, null);
		}
		
		delegate void ReceivedUDPmessageDelegate(string message, string ip);
		
		void ReceivedUDPmessage(string message, string ip)
		{
			textBoxMessagesReceived.AppendText(DateTime.Now.ToLongTimeString() + " @ " + ip + " ← " + message + Environment.NewLine);
			if (groupBoxPilot.Enabled)
				switch (message)
				{
						case "<Stop>": ButtonStopMouseDown(this, null); break;
						case "</Stop>": ButtonStopMouseUp(this, null); break;
						case "<Front/>": ButtonFrontMouseDown(this, null); break;
						case "<Back/>": ButtonBackMouseDown(this, null); break;
						case "<FrontLeft/>": ButtonFrontLeftMouseDown(this, null); break;;
						case "<FrontRight/>": ButtonFrontRightMouseDown(this, null); break;
						case "<BackLeft/>": ButtonBackLeftMouseDown(this, null); break;
						case "<BackRight/>": ButtonBackRightMouseDown(this, null); break;
				}
		}
		
		void ButtonIPslaveClick(object sender, EventArgs e)
		{
			if (numericUpDownIPslave.Enabled)
			{
				numericUpDownIPslave.Enabled = false;
				buttonIPslave.Text = "Close";
				groupBoxIPtransport.Enabled = false;
				IPEndPoint ipEndPointSlave = new IPEndPoint(IPAddress.Any, (int)numericUpDownIPslave.Value);
				udpClientSlave = new UdpClient(ipEndPointSlave);
				udpClientSlave.BeginReceive(new AsyncCallback(UDPmessageReceived), null);
			}
			else
			{
				if (udpClientSlave != null)
				{
					udpClientSlave.Close();
					udpClientSlave = null;
				}
				groupBoxIPtransport.Enabled = true;
				buttonIPslave.Text = "Listen";
				numericUpDownIPslave.Enabled = true;
			}
		}
		#endregion
		
		#region IP master
		UdpClient udpClientMaster;
		
		void ButtonIPmasterClick(object sender, EventArgs e)
		{
			if (numericUpDownIPMaster.Enabled)
			{
				numericUpDownIPMaster.Enabled = false;
				textBoxIP.Enabled = false;
				buttonIPmaster.Text = "Close";
				groupBoxIPtransport.Enabled = false;
				udpClientMaster = new UdpClient(textBoxIP.Text, (int)numericUpDownIPMaster.Value);
				groupBoxPilot.Enabled = true;
			}
			else
			{
				groupBoxPilot.Enabled = true;
				if (udpClientMaster != null)
				{
					udpClientMaster.Close();
					udpClientMaster = null;
				}
				groupBoxIPtransport.Enabled = true;
				buttonIPmaster.Text = "Activate";
				textBoxIP.Enabled = true;
				numericUpDownIPMaster.Enabled = true;
			}
		}
		
		void SendUDPmessage(string message)
		{
			if (udpClientMaster == null) return;
			textBoxMessagesReceived.AppendText(DateTime.Now.ToLongTimeString() + " @ " + textBoxIP.Text + " → " + message + Environment.NewLine);
			Byte[] bytes = Encoding.UTF8.GetBytes(message);
			try
			{
				udpClientMaster.Send(bytes, bytes.Length);
			}
			catch (Exception e)
			{
				textBoxMessagesReceived.AppendText(e.ToString());
			}
		}
		#endregion
	}
}
